﻿
using CallCenter.Settings;
using XF.Domain.Cache;
using XF.Domain.Dependency;

namespace CallCenter.Caches
{
    public class DaySettingCacheManager : IDaySettingCacheManager, IScopeDependency
    {
        private readonly ITypedCache<IReadOnlyList<DaySetting>> _daySettingCache;
        private readonly IDaySettingRepository _daySettingRepository;
        public DaySettingCacheManager(ITypedCache<IReadOnlyList<DaySetting>> daySettingCache,IDaySettingRepository daySettingRepository)
        {
            _daySettingCache = daySettingCache;
            _daySettingRepository = daySettingRepository;

        }
        public IReadOnlyList<DaySetting> GetDaySettings()
        {
            return _daySettingCache.GetOrAdd(DaySetting.Key, _daySettingRepository.QueryAsync().GetAwaiter().GetResult());
        }
    }
}
